题目链接:Here

题意:把 \(n\) 个数变成 \(k\) 个相同的数,每次可以把 \(n\) 个数里最大的 \(-1\) 或最小的 \(+1\) ,问最小改变次数

思路:

我们可以枚举,把 \(n\) 个数变成 \(k\) 个 \(a[i]\) (这个相同的数一定是数组里的数,因为如果不是,那么改变次数一定会比正常多)

如果相同的数大于 \(k\) 个,那么改变次数为 \(0\) ,特判掉

有三种情况,一种是只动前面,一种只动后面,还有就是前后都动

因为是改变最大或最小的数,所以我们只有把所有小于 \(a[i]\) 的数变成 \(a[i]-1\) (或者大于 \(a[i]\) 的数变成\(a[i]+1\) )才能进行下一次的改变

然后接着考虑,在什么情况下可以动前面呢,当然是他前面的数大于\((k-1)\)个,同理,在他后面的数大于 \((k-1)\) 个时才可以动后面,然后在任何情况下都可以前后都动( 在$(i=1) $时就相当于是动后面结果不冲突)

以只动前面为例

\(tem1 = (\sum\limits_{j=1}^i((a[i] - 1) -a[j]) + k\)

化简一下发现

\(tem1 = \sum\limits_{j=1}^i(a[i] - 1) -\sum\limits_{j=1}^ia[j] + k\)​

就是 \(i*(a[i]-1)-a[i]\) 的前缀和 \(+k\) ,提前搞一个前缀和可以降低时间复杂度

只动后面同理

\(tmp2 = \sum\limits_{j=i}^na[i] -\sum\limits_{j=i}^n(a[j] + 1) + k\)

动两边,这时相等的数的个数恰好为 \(n\) ,把他们都搞成 \(a[i]\) 然后再减掉多余的

\(tmp3 = \sum\limits_{j=i}^na[j] - \sum\limits_{j=1}^ia[j] + \sum\limits_{j=1}^ia[i] - \sum\limits_{j=i}^na[i] - (n - k)\)

记录好前缀和 和(后缀和?)就可以用 \(\mathcal{O}(n)\)​ 的复杂度解决掉这个问题了

#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll inf = 1e17;
ll a[200009];
ll cnt[200009];
ll sumq[200009], sumh[200009];
int main() {
int n, k;
ll ans = inf;
scanf("%d%d", &n, &k);
for (int i = 1; i <= n; i++) {
scanf("%lld", &a[i]);
}
sort(a + 1, a + 1 + n);
for (int i = 1; i <= n; i++) sumq[i] = sumq[i - 1] + a[i];
for (int i = n; i >= 1; i--) sumh[i] = sumh[i + 1] + a[i];
for (int i = 1; i <= n; i++) {
if (a[i] == a[i - 1])cnt[i] = cnt[i - 1] + 1;
else cnt[i] = 1;
if (cnt[i] >= k) {
puts("0");
return 0;
}
}
for (int i = 1; i <= n; i++) {
if (i >= k) {
ll tem1 = i * (a[i] - 1) - sumq[i] + k;
ans = min(tem1, ans);
}
if (n - i + 1 >= k) {
ll tem2 = n - i + 1;
tem2 = sumh[i] - tem2 * (a[i] + 1) + k;
ans = min(tem2, ans);
}
if (i < k && (n - i + 1) < k) {
ll tem3 = i * a[i] - sumq[i] + sumh[i] - (n - i + 1) * a[i] - (n - k);
ans = min(tem3, ans);
}
}
printf("%lld\n", ans);
return 0;
}

便捷写法

int main() {
cin.tie(nullptr)->sync_with_stdio(false);
int n, k;
cin >> n >> k;
vector<ll> a(n);
for (ll &x : a) cin >> x;
sort(a.begin(), a.end());
for (int i = 0; i + k - 1 < n; ++i) {
if (a[i] == a[i + k - 1])
return printf("0\n"), 0;
} ll lcost = 0;
ll rcost = 0;
for (int i = 0; i < k; ++i) {
lcost += a[k - 1] - a[i];
rcost += a[n - 1 - i] - a[n - k];
}
for (int j = k; j < n; ++j) {
if (a[k - 1] == a[j]) lcost--;
if (a[n - k] == a[n - 1 - j]) rcost--;
}
ll sum = 0;
for (int i = 0; i < n - 1 - i; ++i) sum += a[n - 1 - i] - a[i];
ll ans = min(sum - (n - k), min(lcost, rcost));
cout << ans;
}

题解 | CF1328F. Make k Equal (思维,前缀 & 后缀和)的更多相关文章

  1. [JZOJ5280]膜法师题解--思维+前缀和

    [JZOJ5280]膜法师题解--思维+前缀和 题目链接 暴 力 过 于

  2. Codeforces Round #320 (Div. 2) [Bayan Thanks-Round] D "Or" Game 枚举+前缀后缀

                                                                            D. "Or" Game       ...

  3. POJ 2752 (KMP 所有可能长度的前缀后缀) Seek the Name, Seek the Fame

    题意: 求一个字符串的相同前缀后缀的所有可能的长度,这里该字符串其本身也算自己的前缀和后缀. 分析: 我们知道next数组的性质是,该字符之前的字符串的最大相同前缀后缀. 既然知道了最大的,即next ...

  4. hdoj 2594 Simpsons’ Hidden Talents 【KMP】【求串的最长公共前缀后缀】

    Simpsons' Hidden Talents Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java ...

  5. CF-1328 F. Make k Equal

    F. Make k Equal 题目链接 题意 长度为n的序列,每次可以选择一个最大的数字将其减一或者选择一个最小的数字将其加一,问最少操作多少次可以使得序列中至少存在 k 个一样的数字 分析 官方题 ...

  6. k倍区间 前缀和【蓝桥杯2017 C/C++ B组】

    标题: k倍区间 给定一个长度为N的数列,A1, A2, ... AN,如果其中一段连续的子序列Ai, Ai+1, ... Aj(i <= j)之和是K的倍数,我们就称这个区间[i, j]是K倍 ...

  7. 1280 前缀后缀集合(map)

    1280 前缀后缀集合 题目来源: Codility 基准时间限制:1 秒 空间限制:131072 KB 分值: 40 难度:4级算法题 一个数组包含N个正整数,其中有些是重复的.一个前缀后缀集是满足 ...

  8. kuangbin专题七 HDU1540 Tunnel Warfare (前缀后缀线段树)

    During the War of Resistance Against Japan, tunnel warfare was carried out extensively in the vast a ...

  9. jQuery EasyUI/TopJUI基本的数字输入框(保留两位小数,带前缀后缀...)

    jQuery EasyUI/TopJUI基本的数字输入框(保留两位小数,带前缀后缀...) numberbox(数值输入框) HTML required:必填字段,默认为false:prompt:显示 ...

  10. 求x!在k进制下后缀零的个数(洛谷月赛T1)

    求x!在k进制下后缀和的个数 20分:     求十进制下的x!后缀和的个数 40分: 高精求阶乘,直接模拟过程 (我不管反正我不打,本蒟蒻最讨厌高精了) 60分     利用一个定理(网上有求x!在 ...

随机推荐

  1. Android 实现APP可切换多语言

    原文: Android 实现APP可切换多语言 - Stars-One的杂货小窝 如果是单独给app加上国际化,其实很容易,创建对应的国家资源文件夹即可,如values-en,values-pt,ap ...

  2. 从0开始用Maven

    一.Maven的介绍即相关概念 Maven是一款构建和管理Java项目的工具,它将项目开发和管理过程抽象成一个项目对象模型(POM),提供了一种统一的项目结构. Maven官网 1.为什么使用Mave ...

  3. 分布式文件系统HDFS简介

    HDFS实现目标: 兼容廉价的硬件设备    支持大数据集   实现流数据读写   支持简单的文件模型    强大的跨平台兼容性 自身的局限性: 不适合低延迟的数据访问   无法高效储存大量小文件  ...

  4. Android SDK Manager 报错“加载 SDK 组件信息失败”。(Android SDK Manager complains with "Loading SDK component information failed."

    [解决方案]: 将存储库设置更改为 Google .因此,在 android SDK 管理器上点击齿轮图标(设置),然后点击 Repository -> Google.

  5. WinRM服务应用及配置说明

    一.什么是winRM服务 1.1.winRM服务介绍 Windows远程管理(WinRM)服务是Windows Server 2003 R2以上版本中一种新式的方便远程管理的服务.通过WinRM服务, ...

  6. Shiro-550反序列化漏洞(CVE-2016-4437)复现

    本文章使用Shiro_exploit此工具复现,靶机环境为vulhub 项目地址: https://github.com/insightglacier/Shiro_exploit https://gi ...

  7. 39. 干货系列从零用Rust编写负载均衡及代理,正则及格式替换

    wmproxy wmproxy已用Rust实现http/https代理, socks5代理, 反向代理, 静态文件服务器,四层TCP/UDP转发,七层负载均衡,内网穿透,后续将实现websocket代 ...

  8. 文心一言 VS 讯飞星火 VS chatgpt (175)-- 算法导论13.3 4题

    四.用go语言,Teach 教授担心 RB-INSERT-FIXUP可能将 T.nil.color 设为 RED,这时,当 z 为根时第1行的测试就不会让循环终止.通过讨论 RB-INSERT-FIX ...

  9. 2023-10-11:用go语言,一个数字n,一定要分成k份, 得到的乘积尽量大是多少? 数字n和k,可能非常大,到达10^12规模。 结果可能更大,所以返回结果对1000000007取模。 来自华为

    2023-10-11:用go语言,一个数字n,一定要分成k份, 得到的乘积尽量大是多少? 数字n和k,可能非常大,到达10^12规模. 结果可能更大,所以返回结果对1000000007取模. 来自华为 ...

  10. 中秋国庆花式玩法,用低代码DIY假日大屏“Vlog”

    ​​本文分享自华为云社区 <[云享热点]中秋国庆花式玩法,用低代码DIY假日大屏"Vlog"(内附节日福利)>,作者:华为云社区精选. 中秋.国庆双节将至,你的八天小长 ...